# coding: utf-8

"""
    Hydrogen Proton API

    Financial engineering module of Hydrogen Atom  # noqa: E501

    OpenAPI spec version: 1.8.0
    Contact: info@hydrogenplatform.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from proton_api.api_client import ApiClient


class LifeInsuranceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def life_insurance_needs_calculator(self, life_insurance_needs_calculator_request, **kwargs):  # noqa: E501
        """Life Insurance Needs Calculator  # noqa: E501

        Calculate life insurance needs based on existing asset and liability data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.life_insurance_needs_calculator(life_insurance_needs_calculator_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LifeInsuranceNeedsCalculatorRequest life_insurance_needs_calculator_request: Request payload for Life Insurance Needs Calculator (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.life_insurance_needs_calculator_with_http_info(life_insurance_needs_calculator_request, **kwargs)  # noqa: E501
        else:
            (data) = self.life_insurance_needs_calculator_with_http_info(life_insurance_needs_calculator_request, **kwargs)  # noqa: E501
            return data

    def life_insurance_needs_calculator_with_http_info(self, life_insurance_needs_calculator_request, **kwargs):  # noqa: E501
        """Life Insurance Needs Calculator  # noqa: E501

        Calculate life insurance needs based on existing asset and liability data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.life_insurance_needs_calculator_with_http_info(life_insurance_needs_calculator_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LifeInsuranceNeedsCalculatorRequest life_insurance_needs_calculator_request: Request payload for Life Insurance Needs Calculator (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['life_insurance_needs_calculator_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method life_insurance_needs_calculator" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'life_insurance_needs_calculator_request' is set
        if ('life_insurance_needs_calculator_request' not in params or
                params['life_insurance_needs_calculator_request'] is None):
            raise ValueError("Missing the required parameter `life_insurance_needs_calculator_request` when calling `life_insurance_needs_calculator`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'life_insurance_needs_calculator_request' in params:
            body_params = params['life_insurance_needs_calculator_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/life_insurance/needs_calculator', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
