# coding: utf-8

"""
    Hydrogen Proton API

    Financial engineering module of Hydrogen Atom  # noqa: E501

    OpenAPI spec version: 1.8.0
    Contact: info@hydrogenplatform.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class BusinessInvoiceAnalysisRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'customer_id': 'str',
        'end_date': 'date',
        'overdue_periods': 'list[Periods]',
        'client_id': 'str',
        'response_limit': 'int',
        'currency_conversion': 'str',
        'history_frequency_interval': 'str',
        'start_date': 'date',
        'show_history': 'bool',
        'currency_code': 'str',
        'invoice_ids': 'list[str]',
        'show_outstanding_invoices': 'bool',
        'future_due_periods': 'list[Periods]'
    }

    attribute_map = {
        'customer_id': 'customer_id',
        'end_date': 'end_date',
        'overdue_periods': 'overdue_periods',
        'client_id': 'client_id',
        'response_limit': 'response_limit',
        'currency_conversion': 'currency_conversion',
        'history_frequency_interval': 'history_frequency_interval',
        'start_date': 'start_date',
        'show_history': 'show_history',
        'currency_code': 'currency_code',
        'invoice_ids': 'invoice_ids',
        'show_outstanding_invoices': 'show_outstanding_invoices',
        'future_due_periods': 'future_due_periods'
    }

    def __init__(self, customer_id=None, end_date=None, overdue_periods=None, client_id=None, response_limit=10, currency_conversion=None, history_frequency_interval='month', start_date=None, show_history=False, currency_code=None, invoice_ids=None, show_outstanding_invoices=False, future_due_periods=None):  # noqa: E501
        """BusinessInvoiceAnalysisRequest - a model defined in Swagger"""  # noqa: E501

        self._customer_id = None
        self._end_date = None
        self._overdue_periods = None
        self._client_id = None
        self._response_limit = None
        self._currency_conversion = None
        self._history_frequency_interval = None
        self._start_date = None
        self._show_history = None
        self._currency_code = None
        self._invoice_ids = None
        self._show_outstanding_invoices = None
        self._future_due_periods = None
        self.discriminator = None

        if customer_id is not None:
            self.customer_id = customer_id
        if end_date is not None:
            self.end_date = end_date
        if overdue_periods is not None:
            self.overdue_periods = overdue_periods
        if client_id is not None:
            self.client_id = client_id
        if response_limit is not None:
            self.response_limit = response_limit
        if currency_conversion is not None:
            self.currency_conversion = currency_conversion
        if history_frequency_interval is not None:
            self.history_frequency_interval = history_frequency_interval
        if start_date is not None:
            self.start_date = start_date
        if show_history is not None:
            self.show_history = show_history
        if currency_code is not None:
            self.currency_code = currency_code
        if invoice_ids is not None:
            self.invoice_ids = invoice_ids
        if show_outstanding_invoices is not None:
            self.show_outstanding_invoices = show_outstanding_invoices
        if future_due_periods is not None:
            self.future_due_periods = future_due_periods

    @property
    def customer_id(self):
        """Gets the customer_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The customer_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._customer_id

    @customer_id.setter
    def customer_id(self, customer_id):
        """Sets the customer_id of this BusinessInvoiceAnalysisRequest.


        :param customer_id: The customer_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._customer_id = customer_id

    @property
    def end_date(self):
        """Gets the end_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The end_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: date
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this BusinessInvoiceAnalysisRequest.


        :param end_date: The end_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: date
        """

        self._end_date = end_date

    @property
    def overdue_periods(self):
        """Gets the overdue_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The overdue_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: list[Periods]
        """
        return self._overdue_periods

    @overdue_periods.setter
    def overdue_periods(self, overdue_periods):
        """Sets the overdue_periods of this BusinessInvoiceAnalysisRequest.


        :param overdue_periods: The overdue_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: list[Periods]
        """

        self._overdue_periods = overdue_periods

    @property
    def client_id(self):
        """Gets the client_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The client_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this BusinessInvoiceAnalysisRequest.


        :param client_id: The client_id of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._client_id = client_id

    @property
    def response_limit(self):
        """Gets the response_limit of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The response_limit of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: int
        """
        return self._response_limit

    @response_limit.setter
    def response_limit(self, response_limit):
        """Sets the response_limit of this BusinessInvoiceAnalysisRequest.


        :param response_limit: The response_limit of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: int
        """
        if response_limit is not None and response_limit < 1:  # noqa: E501
            raise ValueError("Invalid value for `response_limit`, must be a value greater than or equal to `1`")  # noqa: E501

        self._response_limit = response_limit

    @property
    def currency_conversion(self):
        """Gets the currency_conversion of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The currency_conversion of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._currency_conversion

    @currency_conversion.setter
    def currency_conversion(self, currency_conversion):
        """Sets the currency_conversion of this BusinessInvoiceAnalysisRequest.


        :param currency_conversion: The currency_conversion of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._currency_conversion = currency_conversion

    @property
    def history_frequency_interval(self):
        """Gets the history_frequency_interval of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The history_frequency_interval of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._history_frequency_interval

    @history_frequency_interval.setter
    def history_frequency_interval(self, history_frequency_interval):
        """Sets the history_frequency_interval of this BusinessInvoiceAnalysisRequest.


        :param history_frequency_interval: The history_frequency_interval of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["day", "week", "month", "quarter", "year"]  # noqa: E501
        if history_frequency_interval not in allowed_values:
            raise ValueError(
                "Invalid value for `history_frequency_interval` ({0}), must be one of {1}"  # noqa: E501
                .format(history_frequency_interval, allowed_values)
            )

        self._history_frequency_interval = history_frequency_interval

    @property
    def start_date(self):
        """Gets the start_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The start_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this BusinessInvoiceAnalysisRequest.


        :param start_date: The start_date of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: date
        """

        self._start_date = start_date

    @property
    def show_history(self):
        """Gets the show_history of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The show_history of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._show_history

    @show_history.setter
    def show_history(self, show_history):
        """Sets the show_history of this BusinessInvoiceAnalysisRequest.


        :param show_history: The show_history of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._show_history = show_history

    @property
    def currency_code(self):
        """Gets the currency_code of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The currency_code of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._currency_code

    @currency_code.setter
    def currency_code(self, currency_code):
        """Sets the currency_code of this BusinessInvoiceAnalysisRequest.


        :param currency_code: The currency_code of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._currency_code = currency_code

    @property
    def invoice_ids(self):
        """Gets the invoice_ids of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The invoice_ids of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._invoice_ids

    @invoice_ids.setter
    def invoice_ids(self, invoice_ids):
        """Sets the invoice_ids of this BusinessInvoiceAnalysisRequest.


        :param invoice_ids: The invoice_ids of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: list[str]
        """

        self._invoice_ids = invoice_ids

    @property
    def show_outstanding_invoices(self):
        """Gets the show_outstanding_invoices of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The show_outstanding_invoices of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._show_outstanding_invoices

    @show_outstanding_invoices.setter
    def show_outstanding_invoices(self, show_outstanding_invoices):
        """Sets the show_outstanding_invoices of this BusinessInvoiceAnalysisRequest.


        :param show_outstanding_invoices: The show_outstanding_invoices of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._show_outstanding_invoices = show_outstanding_invoices

    @property
    def future_due_periods(self):
        """Gets the future_due_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501


        :return: The future_due_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :rtype: list[Periods]
        """
        return self._future_due_periods

    @future_due_periods.setter
    def future_due_periods(self, future_due_periods):
        """Sets the future_due_periods of this BusinessInvoiceAnalysisRequest.


        :param future_due_periods: The future_due_periods of this BusinessInvoiceAnalysisRequest.  # noqa: E501
        :type: list[Periods]
        """

        self._future_due_periods = future_due_periods

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BusinessInvoiceAnalysisRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BusinessInvoiceAnalysisRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
